import java.awt.*;
import java.applet.Applet;

public class MessDisp extends Applet implements Runnable{
	Messenger mss;
	String mess,fnt;
	int ii[] = new int[4];
	int ifnt[] = new int[2];
	int iixy[] = new int[2];
	int itextw = 0;
	int iarea,nx,ny;

	Thread messenger = null;

	MessDisp(Messenger mss,String message,
		  int[] i,int[] j,String ft,int[] ift,int[] ixy)
	{
		int jj[] = new int[3];

		this.mss = mss;
		mess = message;
		ii = i;
		jj = j;
		fnt = ft;
		ifnt = ift;
		iixy = ixy;
		iarea = (int)(iixy[0]*0.8);
		int ifntmin = (int)(iixy[1]/0.9);
		if(ifnt[1] > ifntmin)ifnt[1] = ifntmin;

		Font font = new Font(fnt,ifnt[0],ifnt[1]);
		FontMetrics fm = getFontMetrics(font);
		int w = (int)(fm.stringWidth(mess)/2);
		nx = (int)((iarea - w)*Math.random()); 
		ny = (int)(iixy[1]/2+ifnt[1]*0.35);
		Color col = new Color(jj[0],jj[1],jj[2]);
		setBackground(col);
	}

	public Dimension preferredSize(){
		return new Dimension(iarea,iixy[1]);
	}

	public void paint(Graphics g){
		Font font = new Font(fnt,ifnt[0],ifnt[1]);
		g.setFont(font);
		if(ii[3] == -1){
			ii[0] = (int)(Math.random()*256);
			ii[1] = (int)(Math.random()*256);
			ii[2] = (int)(Math.random()*256);
		}
		Color color = new Color(ii[0],ii[1],ii[2]);
		g.setColor(color);
		g.drawString(mess,nx,ny);
		FontMetrics fm = g.getFontMetrics();
		itextw = fm.stringWidth(mess+" ");
	}

	public void repaint(Graphics g){
		paint(g);
	}

	public void setXPosition(){
		nx = nx - 3;
		if(nx < -(itextw)){
			nx = size().width;
		}
	}

	public void start(){
		if(messenger == null){
			messenger = new Thread(this);
			messenger.start();
		}
	}

	public void stop(){
		messenger.stop();
		messenger = null;
	}

	public void run(){
		while(messenger != null){
			try{
				Thread.currentThread().sleep(100);
			}
			catch(InterruptedException e);
			setXPosition();
			repaint();
		}
	}
}

